﻿namespace S7_PLC_Monitoring
{
    using S7.Net;
    using System;
    using System.Threading;
    using System.Windows.Forms;
    using System.Configuration;

    /// <summary>
    /// Defines the <see cref="DataDisplayForm" />.
    /// Forma korištena za testiranje čitanja s PLC-a,
    /// to be removed
    /// </summary>
    public partial class DataDisplayForm : Form
    {
        /// <summary>
        /// Defines the plc.
        /// </summary>
        public Plc plc;

        /// <summary>
        /// Initializes a new instance of the <see cref="DataDisplayForm"/> class.
        /// </summary>
        /// <param name="plc">The plc<see cref="Plc"/>.</param>
        /// <param name="json_file_path">The json_file_path<see cref="string"/>.</param>
        public DataDisplayForm(Plc plc, string json_file_path, string plc_type)
        {
            this.plc = plc;

            InitializeComponent();
            dataDisplaySecondaryControl1.Fill_event_selection(json_file_path);
            monitoringControl1.Fill_event_selection(json_file_path);
            dataDisplayMainControl1.Fill_event_selection(json_file_path);

            this.dataDisplaySecondaryControl1.plc = plc;
            this.dataDisplaySecondaryControl1.plc_type = plc_type;

            this.monitoringControl1.plc = plc;
            this.monitoringControl1.plc_type = plc_type;
            
            this.dataDisplayMainControl1.plc = plc;
            this.dataDisplayMainControl1.plc_type = plc_type;

            dataDisplaySecondaryControl1.Hide();
            dataDisplayMainControl1.BringToFront();
             }

        /// <summary>
        /// The change_plc_btn_Click.
        /// </summary>
        /// <param name="sender">The sender<see cref="object"/>.</param>
        /// <param name="e">The e<see cref="EventArgs"/>.</param>
        private void change_plc_btn_Click(object sender, EventArgs e)
        {
            var display_form_thread = new Thread(() => Application.Run(new ConnectionFom()));
            display_form_thread.SetApartmentState(ApartmentState.STA);
            display_form_thread.Start();
            System.Windows.Forms.Application.Exit();
        }

        /// <summary>
        /// The general_data_btn_Click.
        /// </summary>
        /// <param name="sender">The sender<see cref="object"/>.</param>
        /// <param name="e">The e<see cref="EventArgs"/>.</param>
        private void general_data_btn_Click(object sender, EventArgs e)
        {
            dataDisplayMainControl1.Show();
            dataDisplayMainControl1.BringToFront();
            dataDisplaySecondaryControl1.Hide();
            monitoringControl1.Hide();
        }

        /// <summary>
        /// The specific_data_button_Click.
        /// </summary>
        /// <param name="sender">The sender<see cref="object"/>.</param>
        /// <param name="e">The e<see cref="EventArgs"/>.</param>
        private void specific_data_button_Click(object sender, EventArgs e)
        {
            dataDisplaySecondaryControl1.Show();
            dataDisplaySecondaryControl1.BringToFront();
            dataDisplayMainControl1.Hide();
            monitoringControl1.Hide();
        }

        /// <summary>
        /// The monitor_data_btn_Click.
        /// </summary>
        /// <param name="sender">The sender<see cref="object"/>.</param>
        /// <param name="e">The e<see cref="EventArgs"/>.</param>
        private void monitor_data_btn_Click(object sender, EventArgs e)
        {
            monitoringControl1.Show();
            monitoringControl1.BringToFront();
            dataDisplayMainControl1.Hide();
            dataDisplaySecondaryControl1.Hide();
        }
    }
}
