﻿/// <summary>
/// Not used, can be utilised to crerate graphs from a list of values
/// </summary>
namespace S7_PLC_Monitoring
{
    using LiveCharts;
    using LiveCharts.Wpf;
    using System;
    using System.Windows.Forms;

    /// <summary>
    /// Defines the <see cref="DataDisplayGraphControl" />.
    /// </summary>
    public partial class DataDisplayGraphControl : UserControl
    {
        /// <summary>
        /// Defines the test_vals.
        /// </summary>
        internal int[] test_vals = new int[100];

        /// <summary>
        /// Initializes a new instance of the <see cref="DataDisplayGraphControl"/> class.
        /// </summary>
        public DataDisplayGraphControl()
        {
            InitializeComponent();
        }

        /// <summary>
        /// The RngVals.
        /// </summary>
        private void RngVals()
        {
            int min = 0;
            int max = 100;
            int cmin = min;
            int cmax = max;



            Random randNum = new Random();
            for (int i = 0; i < test_vals.Length; i++)
            {
                if (i != 0)
                {
                    cmin = ((test_vals[i - 1] - 5) > min) ? (test_vals[i - 1] - 5) : min;
                    cmax = ((test_vals[i - 1] + 5) < max) ? (test_vals[i - 1] + 5) : max;
                }
                test_vals[i] = randNum.Next(cmin, cmax);
            }
        }

        /// <summary>
        /// The GenerateTestVals.
        /// </summary>
        private void GenerateTestVals()
        {
            RngVals();
            LiveCharts.SeriesCollection series = new LiveCharts.SeriesCollection
            {

                new LineSeries
                {
                    Title = "Values",
                    Values = new ChartValues<int>(test_vals),
                    PointGeometry = null
                }

            };


            System.Threading.Thread.Sleep(20);
            RngVals();
            series.Add(
                new LineSeries
                {
                    Title = "Values 2",
                    Values = new ChartValues<int>(test_vals),
                    PointGeometry = null
                }
            );
            this.cartesianChart1.Series = series;
        }

        /// <summary>
        /// The DataDisplayGraphControl_Load.
        /// </summary>
        /// <param name="sender">The sender<see cref="object"/>.</param>
        /// <param name="e">The e<see cref="EventArgs"/>.</param>
        private void DataDisplayGraphControl_Load(object sender, EventArgs e)
        {
            GenerateTestVals();
        }

        /// <summary>
        /// The random_btn_Click.
        /// </summary>
        /// <param name="sender">The sender<see cref="object"/>.</param>
        /// <param name="e">The e<see cref="EventArgs"/>.</param>
        private void random_btn_Click(object sender, EventArgs e)
        {
            GenerateTestVals();
            this.cartesianChart1.Refresh();
        }
    }
}
